import * as z from 'zod';
import type { Prisma } from '../../../generated/prisma';
import { PatientArgsObjectSchema as PatientArgsObjectSchema } from './PatientArgs.schema';
import { AppointmentArgsObjectSchema as AppointmentArgsObjectSchema } from './AppointmentArgs.schema';
import { UserArgsObjectSchema as UserArgsObjectSchema } from './UserArgs.schema';
import { StaffArgsObjectSchema as StaffArgsObjectSchema } from './StaffArgs.schema';
import { NpiProviderArgsObjectSchema as NpiProviderArgsObjectSchema } from './NpiProviderArgs.schema';
import { ServiceLineFindManySchema as ServiceLineFindManySchema } from '../findManyServiceLine.schema';
import { ClaimFileFindManySchema as ClaimFileFindManySchema } from '../findManyClaimFile.schema';
import { PaymentArgsObjectSchema as PaymentArgsObjectSchema } from './PaymentArgs.schema';
import { ClaimCountOutputTypeArgsObjectSchema as ClaimCountOutputTypeArgsObjectSchema } from './ClaimCountOutputTypeArgs.schema'

const makeSchema = () => z.object({
  id: z.boolean().optional(),
  patientId: z.boolean().optional(),
  appointmentId: z.boolean().optional(),
  userId: z.boolean().optional(),
  staffId: z.boolean().optional(),
  patientName: z.boolean().optional(),
  memberId: z.boolean().optional(),
  dateOfBirth: z.boolean().optional(),
  remarks: z.boolean().optional(),
  missingTeethStatus: z.boolean().optional(),
  missingTeeth: z.boolean().optional(),
  serviceDate: z.boolean().optional(),
  insuranceProvider: z.boolean().optional(),
  createdAt: z.boolean().optional(),
  updatedAt: z.boolean().optional(),
  status: z.boolean().optional(),
  claimNumber: z.boolean().optional(),
  preAuthNumber: z.boolean().optional(),
  npiProviderId: z.boolean().optional(),
  patient: z.union([z.boolean(), z.lazy(() => PatientArgsObjectSchema)]).optional(),
  appointment: z.union([z.boolean(), z.lazy(() => AppointmentArgsObjectSchema)]).optional(),
  user: z.union([z.boolean(), z.lazy(() => UserArgsObjectSchema)]).optional(),
  staff: z.union([z.boolean(), z.lazy(() => StaffArgsObjectSchema)]).optional(),
  npiProvider: z.union([z.boolean(), z.lazy(() => NpiProviderArgsObjectSchema)]).optional(),
  serviceLines: z.union([z.boolean(), z.lazy(() => ServiceLineFindManySchema)]).optional(),
  claimFiles: z.union([z.boolean(), z.lazy(() => ClaimFileFindManySchema)]).optional(),
  payment: z.union([z.boolean(), z.lazy(() => PaymentArgsObjectSchema)]).optional(),
  _count: z.union([z.boolean(), z.lazy(() => ClaimCountOutputTypeArgsObjectSchema)]).optional()
}).strict();
export const ClaimSelectObjectSchema: z.ZodType<Prisma.ClaimSelect> = makeSchema() as unknown as z.ZodType<Prisma.ClaimSelect>;
export const ClaimSelectObjectZodSchema = makeSchema();
